/*******************************************
紅音製作所 www5.big.or.jp/~high/VENIO/
COPYRIGHT(C)VENIO WORKS ALL RIGHTS RESERVED.
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#define WIW 264
#define WIH 120
#define SIZE_Y 5*3
#define SIZE_X 11*3
#define REC 24
#define IMG_MAX 1
#define MAP_A "Map.app/Contents/Resources/mapA.txt"
#define LINE_1 256

SDL_Surface *screen;//ウィンドウ
SDL_Surface *img[IMG_MAX];//画像用
Uint32 now,fps,cnt;//flame late
Uint8 gameMode;//現在の状態

Sint16 mapSizeY,mapSizeX;//読み込むマップの大きさ格納
Sint16 maps[SIZE_Y][SIZE_X]=
{
	{0,0,0,0,0,0,0,0,0,0,0},
	{0,0,1,1,1,1,1,1,1,0,0},
	{0,0,1,2,2,2,2,2,1,0,0},
	{0,0,1,1,1,1,1,3,1,0,0},
	{0,0,0,0,0,0,0,0,0,0,0}
};
//------------------------------------------------------------------------------マップ読み込み
void mapLoad(char *mapTxt)
{
Sint16 poY=0;  Sint16 poX=0;
char line[LINE_1];//一行読み込み用

FILE *mapFile=fopen(mapTxt,"r");
if(mapFile==NULL){puts("マップデータ読み込み失敗");SDL_Quit();return;}

while( fgets(line,  LINE_1,  mapFile) )//データ読み込み
	{
	char *words=strtok(line, ",");//lineを*wordsに格納用
	if(strcmp("MAP_SIZE",  words)==0)//MAP_SIZE格納
		{
		mapSizeY=atoi(strtok(NULL, ","));
		mapSizeX=atoi(strtok(NULL, ","));
		}
	else if(strcmp("DATA  ",  words)==0)//DATA  格納
		{
		for(poX=0;	poX<mapSizeX;	poX++)//X軸格納
		maps[poY][poX]=atoi(strtok(NULL, ","));
		poY+=1;//次へ
		}
	}
fclose(mapFile);
}
//------------------------------------------------------------------------------準備
void inits()
{
int num;
//初期化
if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK|SDL_INIT_AUDIO)<0)
	{
	fprintf(stderr, "SDL が初期化できませんでした: %s\n", SDL_GetError());
	SDL_Quit();return;
	}
screen=SDL_SetVideoMode(WIW,WIH,32,SDL_SWSURFACE);
SDL_WM_SetCaption("Map", NULL);	gameMode=0;
//画像読み込み
img[0]=IMG_Load("Map.app/Contents/Resources/chipA.png");
for(num=0;	num<IMG_MAX;	num++)
if(!img[num])printf("画像読み込み失敗: %s\n", IMG_GetError());
//マップ読み込み
mapLoad(MAP_A);
}
//------------------------------------------------------------------------------mapチップ
void mapSrc(Sint16 num, Sint16 poX,Sint16 poY)
{
SDL_Rect src,drw;
src.x=num*REC;	src.y=0;	src.w=REC;	src.h=REC;
drw.x=poX;			drw.y=poY;

SDL_BlitSurface(img[0],&src,screen,&drw);
}
//------------------------------------------------------------------------------map全体描画
void mapDrw()
{
Sint16 poX,poY;
for(poY=0;	poY<mapSizeY;	poY++)
for(poX=0;	poX<mapSizeX;	poX++)
mapSrc(maps[poY][poX], poX*REC,	poY*REC);
}
//------------------------------------------------------------------------------画面更新
void upDate()
{
if(SDL_GetTicks()-now<16)SDL_Delay(16-(SDL_GetTicks()-now));
now=SDL_GetTicks();
SDL_UpdateRect(screen,0,0,0,0);//画面更新
if(SDL_GetTicks()-fps>=5000){printf("%d\n",(Uint32)(cnt/5+0.5));cnt=1;fps=now;}
else cnt++;
}
//------------------------------------------------------------------------------終了へ
int quitLoop()
{
SDL_Event endSDL;
if(SDL_PollEvent(&endSDL))
switch(endSDL.type)
	{
	case SDL_KEYDOWN:	if(endSDL.key.keysym.sym==SDLK_ESCAPE)return 0;
	case SDL_QUIT:		return 0;
	default:					break;
	}
return 1;
}
//------------------------------------------------------------------------------メイン
int main(int argc,char *argv[])
{
inits();
while(quitLoop())
	{
	switch(gameMode)
		{
		case 0:
			mapDrw();
			break;
		default:break;
		}
	upDate();//画面更新
	}
SDL_Quit();
return 0;
}